/*
   Copyright (C) 1994-2001 Digitool, Inc
   This file is part of Opensourced MCL.

   Opensourced MCL is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   Opensourced MCL is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



/* Subprims for catch, throw, unwind_protect. */


	include(lisp.s)
	_beginfile
	.globl _SPunbind_to

_spentry(mkcatch1v)
	li imm2,0
	b mkcatch
	
_spentry(mkunwind)
	lwi arg_z,unbound_marker
	/*b _SPmkcatchmv */

_spentry(mkcatchmv)
	li imm2,fixnum_one
	/*b mkcatch */
	
/* Push a catch frame on the temp stack (and some of it on the cstack, as well.) */
/* The PC in question is 4 bytes past the caller's return address. ALWAYS. */
/* The catch tag is in arg_z, the multiple-value flags is in imm2. */
/* Bash some of the imm registers and loc_pc. */

/* THIS HAS TO LOOK ATOMIC TO ANY (future) preemptive scheduler. */
mkcatch:
	mflr loc_pc
	ref_global imm0,catch_top
	lwz imm1,0(loc_pc) /* a forward branch to the catch/unwind cleanup */
	rlwinm imm1,imm1,0,6,29	/* extract LI */
	add loc_pc,loc_pc,imm1
	create_lisp_frame
	stw fn,lisp_frame.savefn(sp)
	stw loc_pc,lisp_frame.savelr(sp)
	stw vsp,lisp_frame.savevsp(sp)
	sub loc_pc,loc_pc,imm1
	la loc_pc,4(loc_pc)	/* skip over the forward branch */
	mtlr loc_pc
	mr initptr,tsp
	stwu tsp,-(catch_frame.size+8)(tsp)
	stw rzero,4(tsp)
	la imm1,8+fulltag_misc(tsp)
	stw arg_z,catch_frame.catch_tag(imm1)
	stw imm0,catch_frame.link(imm1)
	stw imm2,catch_frame.mvflag(imm1)
	ref_global imm0,db_link
	stw sp,catch_frame.csp(imm1)
	lwi imm2,(catch_frame.element_count<<num_subtag_bits)|subtag_catch_frame
	stw imm0,catch_frame.db_link(imm1)
 	stmw first_nvr,catch_frame.regs(imm1)
	stw imm2,catch_frame.header(imm1)
	ref_global imm0,xframe
	stw imm0,catch_frame.xframe(imm1)
	stw rzero,catch_frame.tsp_segment(imm1)
	mr initptr,freeptr
	set_global imm1,catch_top
	blr
	
/* Caller has pushed tag and 0 or more values; nargs = nvalues. */
/* Otherwise, process unwind-protects and throw to indicated catch frame. */
	.globl _SPthrow
_spentry(throw)
	ref_global imm1,catch_top
	li imm0,0 /* count intervening catch/unwind-protect frames. */
	cmpwi cr0,imm1,0
	lwzx temp0,vsp,nargs
	beq- cr0,_throw_tag_not_found
_throw_loop:	lwz temp1,catch_frame.catch_tag(imm1)
	cmpw cr0,temp0,temp1
	mr imm2,imm1
	lwz imm1,catch_frame.link(imm1)
	cmpwi cr1,imm1,0
	beq cr0,_throw_found
	addi imm0,imm0,fixnum_one
	beq- cr1,_throw_tag_not_found
	b _throw_loop
/* imm2: (tstack-consed) target catch frame, imm0: count of intervening frames.
  If target isn't a multiple-value receiver, discard extra values 
  (less hair, maybe.) */
_throw_found:	lwz imm1,catch_frame.mvflag(imm2)
	cmpwi cr0,imm1,0
	cmpwi cr1,nargs,0
	li fn,0
	add imm1,vsp,nargs
	la imm1,-4(imm1)
	bne cr0,_throw_all_values
	set_nargs 1
	beq cr1,_throw_default_1_val
	mr vsp,imm1
	b _throw_all_values
_throw_default_1_val:
	vpush rnil
_throw_all_values:
	bl nthrowvalues
	ref_global imm3,catch_top
	ref_global imm1,db_link
	lwz imm0,catch_frame.db_link(imm3)
	lwz imm4,catch_frame.mvflag(imm3)
	cmpw cr0,imm0,imm1
	cmpwi cr1,imm4,0
	la tsp,-(fulltag_misc+8)(imm3)
	beq cr0,_throw_dont_unbind
	bl _SPunbind_to
_throw_dont_unbind:	
	add imm0,vsp,nargs
	cmpwi cr0,nargs,0
	lwz imm1,catch_frame.csp(imm3)
	lwz imm1,lisp_frame.savevsp(imm1)
	bne cr1,_throw_multiple
/* Catcher expects single value in arg_z */
	lwz arg_z,-4(imm0)
	b _throw_pushed_values
_throw_multiple:
	beq cr0,_throw_pushed_values
	mr imm2,nargs
_throw_mvloop:
	subi imm2,imm2,fixnum_one
	cmpwi imm2,0
	lwzu temp0,-4(imm0)
	push temp0,imm1
	bgt _throw_mvloop
_throw_pushed_values:
	mr vsp,imm1
	lwz sp,catch_frame.csp(imm3)
	lwz fn,lisp_frame.savefn(sp)
	lwz loc_pc,lisp_frame.savelr(sp)
	discard_lisp_frame
	mtlr loc_pc
	lmw first_nvr,catch_frame.regs(imm3)
	lwz imm1,catch_frame.xframe(imm3)
	set_global imm1,xframe
	lwz imm3,catch_frame.link(imm3)
	set_global imm3,catch_top
	unlink tsp
	blr
_throw_tag_not_found:	uuo_interr error_throw_tag_missing,temp0
	stwux temp0,vsp,nargs
	b throw
	
/* This takes N multiple values atop the vstack. */
_spentry(nthrowvalues)
	mr imm4,imm0
_nthrowv_nextframe:
	subi imm4,imm4,fixnum_one
	cmpwi cr1,imm4,0
	ref_global temp0,catch_top
	ref_global imm1,db_link
	bltlr cr1
	lwz imm0,catch_frame.db_link(temp0)
	lwz imm3,catch_frame.link(temp0)
	cmpw cr0,imm0,imm1
	set_global imm3,catch_top
	lwz temp1,catch_frame.catch_tag(temp0)
	cmpwi cr7,temp1,unbound_marker		/* unwind-protect ? */
	lwz sp,catch_frame.csp(temp0)
	beq cr0,_nthrowv_dont_unbind
	 mflr loc_pc
	 bl _SPunbind_to
	 mtlr loc_pc
_nthrowv_dont_unbind:
	beq cr7,_nthrowv_do_unwind
/* A catch frame.  If the last one, restore context from there. */
	bne cr1,_nthrowv_skip
	lwz first_nvr,catch_frame.xframe(temp0)
	set_global first_nvr,xframe
	lwz imm0,lisp_frame.savevsp(sp)
	stw rzero,lisp_frame.savevsp(sp)	/* marker for stack overflow code */
	add imm1,vsp,nargs
	mr imm2,nargs
	b _nthrowv_push_test
_nthrowv_push_loop:
	lwzu temp1,-4(imm1)
	push temp1,imm0
_nthrowv_push_test:
	cmpwi imm2,0
	subi imm2,imm2,fixnum_one
	bne _nthrowv_push_loop
	mr vsp,imm0
	lmw first_nvr,catch_frame.regs(temp0)
	
_nthrowv_skip:
	la tsp,-(8+fulltag_misc)(temp0)
	unlink tsp
	discard_lisp_frame
	b _nthrowv_nextframe
_nthrowv_do_unwind:
/* This is harder.  Call the cleanup code with the multiple values (and */
/* nargs, which is a fixnum.)  Remember the throw count (also a fixnum) */
/* as well. */
/* Save our caller's LR and FN in the csp frame created by the unwind- */
/* protect.  (Clever, eh ?) */
	lwz first_nvr,catch_frame.xframe(temp0)
	set_global first_nvr,xframe
	lmw first_nvr,catch_frame.regs(temp0)
	la tsp,-(8+fulltag_misc)(temp0)
	unlink tsp
	lwz loc_pc,lisp_frame.savelr(sp)
	lwz nfn,lisp_frame.savefn(sp)
	mtctr loc_pc		/* cleanup code address. */
	stw fn,lisp_frame.savefn(sp)
	mflr loc_pc
	mr fn,nfn
	stw loc_pc,lisp_frame.savelr(sp)
	addi imm0,nargs,(8+8)	/* tsp overhead, nargs, throw count */
	neg imm0,imm0
	bitclr imm0,imm0,2
	stwux tsp,tsp,imm0
	stw rzero,4(tsp)
	mr imm2,nargs
	add imm1,nargs,vsp
	sub imm0,tsp,imm0                      /* end of tsp frame */
	stw rzero,-4(imm0)
	la imm0,8(tsp)
	stw nargs,0(imm0)
	b _nthrowv_tpushtest
_nthrowv_tpushloop:	
	lwzu temp0,-4(imm1)
	stwu temp0,4(imm0)
	subi imm2,imm2,fixnum_one
_nthrowv_tpushtest:
	cmpwi imm2,0
	bne _nthrowv_tpushloop
	stwu imm4,4(imm0)
	lwz vsp,lisp_frame.savevsp(sp)
	stw rzero,lisp_frame.savevsp(sp)       /* tell stack overflow code to skip this frame */
	bctrl
	la imm0,8(tsp)
	lwz fn,lisp_frame.savefn(sp)
	lwz loc_pc,lisp_frame.savelr(sp)
	discard_lisp_frame
	mtlr loc_pc
	lwz nargs,0(imm0)
	mr imm2,nargs
	b _nthrowv_tpoptest
_nthrowv_tpoploop:
	lwzu temp0,4(imm0)
	vpush temp0
	subi imm2,imm2,fixnum_one
_nthrowv_tpoptest:
	cmpwi imm2,0
	bne _nthrowv_tpoploop
	lwz imm4,4(imm0)
	unlink tsp
	b _nthrowv_nextframe

/* This is a (slight) optimization.  When running an unwind-protect, */
/* save the single value and the throw count in the tstack frame. */
/* Note that this takes a single value in arg_z. */
_spentry(nthrow1value)
	mr imm4,imm0
nthrow1value_aux:
_nthrow1v_nextframe:
	subi imm4,imm4,fixnum_one
	cmpwi cr1,imm4,0
	ref_global temp0,catch_top
	ref_global imm1,db_link
	set_nargs 1
	bltlr cr1
	lwz imm3,catch_frame.link(temp0)
	lwz imm0,catch_frame.db_link(temp0)
	cmpw cr0,imm0,imm1
	set_global imm3,catch_top
	lwz temp1,catch_frame.catch_tag(temp0)
	cmpwi cr7,temp1,unbound_marker		/* unwind-protect ? */
	lwz sp,catch_frame.csp(temp0)
	beq cr0,_nthrow1v_dont_unbind
	 mflr loc_pc
	 bl _SPunbind_to
	 mtlr loc_pc
_nthrow1v_dont_unbind:
	beq cr7,_nthrow1v_do_unwind
/* A catch frame.  If the last one, restore context from there. */
	bne cr1,_nthrow1v_skip
	lwz vsp,lisp_frame.savevsp(sp)
	lwz first_nvr,catch_frame.xframe(temp0)
	set_global first_nvr,xframe
	lmw first_nvr,catch_frame.regs(temp0)
_nthrow1v_skip:
	la tsp,-(8+fulltag_misc)(temp0)
	unlink tsp
	discard_lisp_frame
	b _nthrow1v_nextframe
_nthrow1v_do_unwind:
/* This is harder, but not as hard (not as much BLTing) as the */
/* multiple-value case. */

/* Save our caller's LR and FN in the csp frame created by the unwind- */
/* protect.  (Clever, eh ?) */
	
	lwz first_nvr,catch_frame.xframe(temp0)
	set_global first_nvr,xframe
	lmw first_nvr,catch_frame.regs(temp0)
	la tsp,-(8+fulltag_misc)(temp0)
	unlink tsp
	lwz loc_pc,lisp_frame.savelr(sp)
	lwz nfn,lisp_frame.savefn(sp)
	mtctr loc_pc		/* cleanup code address. */
	stw fn,lisp_frame.savefn(sp)
	mflr loc_pc
	mr fn,nfn
	stw loc_pc,lisp_frame.savelr(sp)
	stwu tsp,-(8+8)(tsp)	/* tsp overhead, value, throw count */
	stw rzero,4(tsp)
	stw arg_z,8(tsp)
	stw imm4,12(tsp)
	lwz vsp,lisp_frame.savevsp(sp)
	stw rzero,lisp_frame.savevsp(sp)       /* Tell stack overflow code to ignore this frame */
	bctrl
	lwz arg_z,8(tsp)
	lwz imm4,12(tsp)
	lwz fn,lisp_frame.savefn(sp)
	lwz loc_pc,lisp_frame.savelr(sp)
	discard_lisp_frame
	mtlr loc_pc
	unlink tsp
	b _nthrow1v_nextframe
	_endfile

